xfstests: include test subdirectory support
[xfstests-dev.git] / check
diff --git a/check b/check
index ba98ea9fd51f56bb67203f799a01a269bf1a9bb5..da2611a153471d03046ed0a3884b2ffe17a6729e 100755 (executable)
--- a/check
+++ b/check
-#!/bin/sh
+#!/bin/bash
 #
 # Control script for QA
 #
-# Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
-# 
-# This program is free software; you can redistribute it and/or modify it
-# under the terms of version 2 of the GNU General Public License as
+# Copyright (c) 2000-2002,2006 Silicon Graphics, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
 # published by the Free Software Foundation.
-# 
-# This program is distributed in the hope that it would be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-# 
-# Further, this software is distributed without any warranty that it is
-# free of the rightful claim of any third person regarding infringement
-# or the like.  Any license provided herein, whether implied or
-# otherwise, applies only to this software file.  Patent licenses, if
-# any, provided herein do not apply to combinations of this program with
-# other software, or any other product whatsoever.
-# 
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write the Free Software Foundation, Inc., 59
-# Temple Place - Suite 330, Boston MA 02111-1307, USA.
-# 
-# Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
-# Mountain View, CA  94043, or:
-# 
-# http://www.sgi.com 
-# 
-# For further information regarding this notice, see: 
-# 
-# http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
 #
 
 tmp=/tmp/$$
 status=0
 needwrap=true
-try=0
+n_try=0
+try=""
 n_bad=0
 bad=""
 notrun=""
 interrupt=true
+diff="diff -u"
+showme=false
+have_test_arg=false
+randomize=false
+here=`pwd`
+FSTYP=xfs
 
-export QA_CHECK_FS=${QA_CHECK_FS:=true}
+SUPPORTED_TESTS="[0-9][0-9][0-9] [0-9][0-9][0-9][0-9]"
+TEST_GROUP_DIR="tests"
+GENERIC_GROUP_DIR="$TEST_GROUP_DIR/generic"
 
 # generic initialization
 iam=check
-if ! . ./common.rc
-then
-    echo "check: failed to source common.rc"
-    exit 1
-fi
 
-if [ `id -u` -ne 0 ]
-then
-    echo "check: QA must be run as root"
-    exit 1
-fi
+export QA_CHECK_FS=${QA_CHECK_FS:=true}
+
+# by default don't output timestamps
+timestamp=${TIMESTAMP:=false}
+
+# number of diff lines from a failed test, 0 for whole output
+export DIFF_LENGTH=${DIFF_LENGTH:=10}
+
+# by default don't output timestamps
+timestamp=${TIMESTAMP:=false}
+
+usage()
+{
+    echo "Usage: $0 [options] [testlist]"'
+
+check options
+    -xfs                test XFS (default)
+    -udf                test UDF
+    -nfs                test NFS
+    -l                 line mode diff
+    -udiff             show unified diff (default)
+    -n                 show me, do not run tests
+    -T                 output timestamps
+    -r                 randomize test order
+    --large-fs         optimise scratch device for large filesystems
+
+testlist options
+    -g group[,group...]        include tests from these groups
+    -x group[,group...]        exclude tests from these groups
+    NNN                        include test NNN
+    NNN-NNN            include test range (eg. 012-021)
+'
+           exit 0
+}
+
+_setenvironment()
+{
+    MSGVERB="text:action"
+    export MSGVERB
+}
+
+get_group_list()
+{
+       grp=$1
+       dirs=". $GENERIC_GROUP_DIR"
+
+       for d in $dirs; do
+               l=$(sed -n < $d/group \
+                       -e 's/#.*//' \
+                       -e 's/$/ /' \
+                       -e "s;\(^[0-9][0-9][0-9]\).* $grp .*;$d/\1;p")
+               grpl="$grpl $l"
+       done
+       echo $grpl
+}
+
+expand_test_numbers()
+{
+       # strip leading zeros, could be considered octal.
+       start=`echo $1 | sed 's/^0*//'`
+       end=`echo $2 | sed 's/^0*//'`
+
+       $AWK_PROG </dev/null '
+BEGIN  { for (t='$start'; t<='$end'; t++) printf "%03d\n",t }' \
+       | while read id
+       do
+               if grep -s "^$id " group >/dev/null ; then
+                       # in group file ... OK
+                       echo $id >>$tmp.list
+               else
+                       # oops
+                       echo "$id - unknown test, ignored"
+               fi
+       done
+}
 
 _wallclock()
 {
@@ -69,14 +129,153 @@ _timestamp()
     echo -n " [$now]"
 }
 
+# start the initialisation work now
+_setenvironment
+
+rm -f $tmp.list $tmp.tmp $tmp.sed $here/$iam.out
+
+# Autodetect fs type based on what's on $TEST_DEV
+if [ "$HOSTOS" == "Linux" ]; then
+    FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
+fi
+export FSTYP
+
+# we need common.config
+if ! . ./common.config
+then
+    echo "$iam: failed to source common.config"
+    exit 1
+fi
+
+while [ $# -gt 0 ]; do
+       case "$1" in
+       -\? | -h | --help) usage ;;
+
+       -udf)   FSTYP=udf ;;
+       -xfs)   FSTYP=xfs ;;
+       -nfs)   FSTYP=nfs ;;
+
+       -g)     group=$2 ; shift ;
+               group_list=$(get_group_list $group)
+               if [ -z "$group_list" ]; then
+                   echo "Group \"$group\" is empty or not defined?"
+                   exit 1
+               fi
+
+               [ ! -s $tmp.list ] && touch $tmp.list
+               for t in $group_list; do
+                       grep -s "^$t\$" $tmp.list >/dev/null || \
+                                                       echo "$t" >>$tmp.list
+               done
+
+               ;;
+
+       -x)     xgroup=$2 ; shift ;
+               [ ! -s $tmp.list ] &&  ls $SUPPORTED_TESTS >$tmp.list 2>/dev/null
+               group_list=$(get_group_list $xgroup)
+               if [ -z "$group_list" ]; then
+                   echo "Group \"$xgroup\" is empty or not defined?"
+                   exit 1
+               fi
+
+               rm -f $tmp.sed
+               numsed=0
+               for t in $group_list
+               do
+                   if [ $numsed -gt 100 ]; then
+                       sed -f $tmp.sed <$tmp.list >$tmp.tmp
+                       mv $tmp.tmp $tmp.list
+                       numsed=0
+                       rm -f $tmp.sed
+                   fi
+                   echo "/^$t\$/d" >>$tmp.sed
+                   numsed=`expr $numsed + 1`
+               done
+               sed -f $tmp.sed <$tmp.list >$tmp.tmp
+               mv $tmp.tmp $tmp.list
+               ;;
+
+       -l)     diff="diff" ;;
+       -udiff) diff="$diff -u" ;;
+
+       -n)     showme=true ;;
+        -r)    randomize=true ;;
+
+       -T)     timestamp=true ;;
+
+       "$SUPPORTED_TESTS")
+               echo "No tests?"
+               status=1
+               exit $status
+               ;;
+
+       [0-9]*-[0-9]*)
+               eval `echo $1 | sed -e 's/^/start=/' -e 's/-/ end=/'`
+               expand_test_numbers $start $end
+               have_test_arg=true
+               ;;
+
+       [0-9]*-)
+               eval `echo $1 | sed -e 's/^/start=/' -e 's/-//'`
+               end=`echo $SUPPORTED_TESTS | sed -e 's/\[0-9]//g' -e 's/  *$//' -e 's/.* //'`
+               if [ -z "$end" ]; then
+                       echo "No tests in range \"$1\"?"
+                       status=1
+                       exit $status
+               fi
+               expand_test_numbers $start $end
+               have_test_arg=true
+               ;;
+
+       --large-fs) export LARGE_SCRATCH_DEV=yes ;;
+       --extra-space=*) export SCRATCH_DEV_EMPTY_SPACE=${r#*=} ;;
+
+       -*)     usage ;;
+       *)      expand_test_numbers $1 $1 ;
+               have_test_arg=true
+               ;;
+       esac
+
+       shift
+done
+
+if [ -s $tmp.list ]; then
+    # found some valid test numbers ... this is good
+    :
+elif $have_test_arg; then
+       # had test numbers, but none in group file ... do nothing
+       touch $tmp.list
+else
+       # no test numbers, do everything from group file
+       sed -n -e '/^[0-9][0-9][0-9]*/s/[       ].*//p' <group >$tmp.list
+fi
+
+# sort the list of tests into numeric order
+list=`sort -n $tmp.list`
+rm -f $tmp.list $tmp.tmp $tmp.sed
+
+if $randomize
+then
+    list=`echo $list | awk -f randomize.awk`
+fi
+
+# we need common.rc
+if ! . ./common.rc
+then
+    echo "check: failed to source common.rc"
+    exit 1
+fi
+
+if [ `id -u` -ne 0 ]
+then
+    echo "check: QA must be run as root"
+    exit 1
+fi
+
+# Ok, time to start running...
+
 _wrapup()
 {
-    # for hangcheck ...
-    # remove files that were used by hangcheck
-    #
-    [ -f /tmp/check.pid ] && rm -rf /tmp/check.pid
-    [ -f /tmp/check.sts ] && rm -rf /tmp/check.sts
-
     if $showme
     then
        :
@@ -95,101 +294,78 @@ END       { if (NR > 0) {
            mv $tmp.out check.time
        fi
 
-       if [ -f $tmp.expunged ]
-       then
-           notrun=`wc -l <$tmp.expunged | sed -e 's/  *//g'`
-           try=`expr $try - $notrun`
-           list=`echo "$list" | sed -f $tmp.expunged`
-       fi
-
        echo "" >>check.log
        date >>check.log
-       echo $list | fmt | sed -e 's/^/    /' >>check.log
+       echo $list | fmt | sed -e 's/^/    /' -e 's;tests/;;g' >>check.log
        $interrupt && echo "Interrupted!" >>check.log
         
+        if [ ! -z "$n_try" -a $n_try != 0 ]
+       then
+           echo "Ran:$try"
+       fi
+
        if [ ! -z "$notrun" ]
        then
            echo "Not run:$notrun"
            echo "Not run:$notrun" >>check.log
        fi
+
         if [ ! -z "$n_bad" -a $n_bad != 0 ]
        then
            echo "Failures:$bad"
-           echo "Failed $n_bad of $try tests"
+           echo "Failed $n_bad of $n_try tests"
            echo "Failures:$bad" | fmt >>check.log
-           echo "Failed $n_bad of $try tests" >>check.log
+           echo "Failed $n_bad of $n_try tests" >>check.log
        else
-           echo "Passed all $try tests"
-           echo "Passed all $try tests" >>check.log
+           echo "Passed all $n_try tests"
+           echo "Passed all $n_try tests" >>check.log
        fi
        needwrap=false
     fi
 
     rm -f /tmp/*.rawout /tmp/*.out /tmp/*.err /tmp/*.time
-    rm -f /tmp/check.pid /tmp/check.sts
     rm -f $tmp.*
 }
 
 trap "_wrapup; exit \$status" 0 1 2 3 15
 
-# for hangcheck ...
-# Save pid of check in a well known place, so that hangcheck can be sure it
-# has the right pid (getting the pid from ps output is not reliable enough).
-#
-rm -rf /tmp/check.pid
-echo $$ >/tmp/check.pid
-
-# for hangcheck ...
-# Save the status of check in a well known place, so that hangcheck can be
-# sure to know where check is up to (getting test number from ps output is
-# not reliable enough since the trace stuff has been introduced).
-#
-rm -rf /tmp/check.sts
-echo "preamble" >/tmp/check.sts
-
 # don't leave old full output behind on a clean run
 rm -f check.full
 
-# by default don't output timestamps
-timestamp=${TIMESTAMP:=false}
-
-. ./common
-
 [ -f check.time ] || touch check.time
 
-FULL_FSTYP_DETAILS=`_full_fstyp_details`
-FULL_HOST_DETAILS=`_full_platform_details`
-FULL_MKFS_OPTIONS=`_scratch_mkfs_options`
-FULL_MOUNT_OPTIONS=`_scratch_mount_options`
-
-cat <<EOF
-FSTYP         -- $FULL_FSTYP_DETAILS
-PLATFORM      -- $FULL_HOST_DETAILS
-MKFS_OPTIONS  -- $FULL_MKFS_OPTIONS
-MOUNT_OPTIONS -- $FULL_MOUNT_OPTIONS
-
-EOF
-
-umount $SCRATCH_DEV 2>/dev/null
-# call the overridden mkfs.xfs - make sure the FS is built
-# the same as we'll create it later.
-
-if ! _scratch_mkfs_xfs $flag >$tmp.err 2>&1
-then
-    echo "our local _scratch_mkfs_xfs routine ..."
-    cat $tmp.err
-    echo "check: failed to mkfs.xfs \$SCRATCH_DEV using specified options"
-    exit 1
+# print out our test configuration
+echo "FSTYP         -- `_full_fstyp_details`"
+echo "PLATFORM      -- `_full_platform_details`"
+if [ ! -z "$SCRATCH_DEV" ]; then
+  echo "MKFS_OPTIONS  -- `_scratch_mkfs_options`"
+  echo "MOUNT_OPTIONS -- `_scratch_mount_options`"
 fi
-
-# call the overridden mount - make sure the FS mounts with
-# the same options that we'll mount with later.
-if ! _scratch_mount >$tmp.err 2>&1
-then
-    echo "our local mount routine ..."
-    cat $tmp.err
-    echo "check: failed to mount \$SCRATCH_DEV using specified options"
-    exit 1
+echo
+
+
+if [ ! -z "$SCRATCH_DEV" ]; then
+  umount $SCRATCH_DEV 2>/dev/null
+  # call the overridden mkfs - make sure the FS is built
+  # the same as we'll create it later.
+
+  if ! _scratch_mkfs $flag >$tmp.err 2>&1
+  then
+      echo "our local _scratch_mkfs routine ..."
+      cat $tmp.err
+      echo "check: failed to mkfs \$SCRATCH_DEV using specified options"
+      exit 1
+  fi
+
+  # call the overridden mount - make sure the FS mounts with
+  # the same options that we'll mount with later.
+  if ! _scratch_mount >$tmp.err 2>&1
+  then
+      echo "our local mount routine ..."
+      cat $tmp.err
+      echo "check: failed to mount \$SCRATCH_DEV using specified options"
+      exit 1
+  fi
 fi
 
 seq="check"
@@ -198,25 +374,27 @@ _check_test_fs
 for seq in $list
 do
     err=false
-    echo -n "$seq"
+
+    # the filename for the test and the name output are different.
+    # we don't include the tests/ directory in the name output.
+    seqnum=`echo $seq | sed -e 's;tests/;;'`
+
+    echo -n "$seqnum"
+
     if $showme
     then
        echo
        continue
-    elif [ -f expunged ] && $expunge && egrep "^$seq([         ]|\$)" expunged >/dev/null
-    then
-       echo " - expunged"
-       rm -f $seq.out.bad
-       echo "/^$seq\$/d" >>$tmp.expunged
     elif [ ! -f $seq ]
     then
        echo " - no such test?"
-       echo "/^$seq\$/d" >>$tmp.expunged
     else
        # really going to try and run this one
        #
        rm -f $seq.out.bad
-       lasttime=`sed -n -e "/^$seq /s/.* //p" <check.time`
+
+       # slashes now in names, sed barfs on them so use grep
+       lasttime=`grep -w ^$seq check.time | awk '// {print $2}'`
        if [ "X$lasttime" != X ]; then
                echo -n " ${lasttime}s ..."
        else
@@ -224,12 +402,10 @@ do
        fi
        rm -f core $seq.notrun
 
-       # for hangcheck ...
-       echo "$seq" >/tmp/check.sts
-
        start=`_wallclock`
        $timestamp && echo -n " ["`date "+%T"`"]"
        [ ! -x $seq ] && chmod u+x $seq # ensure we can run it
+       $LOGGER_PROG "run xfstest $seqnum"
        ./$seq >$tmp.rawout 2>&1
        sts=$?
        $timestamp && _timestamp
@@ -248,9 +424,9 @@ do
        if [ -f $seq.notrun ]
        then
            $timestamp || echo -n " [not run] "
-           $timestamp && echo " [not run]" && echo -n "        $seq -- "
+           $timestamp && echo " [not run]" && echo -n "        $seqnum -- "
            cat $seq.notrun
-           notrun="$notrun $seq"
+           notrun="$notrun $seqnum"
        else
            if [ $sts -ne 0 ]
            then
@@ -264,17 +440,27 @@ do
            else
                if diff $seq.out $tmp.out >/dev/null 2>&1
                then
-                   echo ""
                    if $err
                    then
                        :
                    else
-                       echo "$seq `expr $stop - $start`" >>$tmp.time
+                       echo "$seqnum `expr $stop - $start`" >>$tmp.time
+                       echo -n " `expr $stop - $start`s"
                    fi
+                   echo ""
                else
                    echo " - output mismatch (see $seq.out.bad)"
                    mv $tmp.out $seq.out.bad
-                   $diff $seq.out $seq.out.bad
+                   $diff $seq.out $seq.out.bad | {
+                       if test "$DIFF_LENGTH" -le 0; then
+                               cat
+                       else
+                               head -n "$DIFF_LENGTH"
+                       fi; } | \
+                       sed -e 's/^\(.\)/    \1/'
+                   echo "     ..."
+                   echo "     (Run '$diff $seq.out $seq.out.bad' to see the" \
+                        "entire diff)"
                    err=true
                fi
            fi
@@ -286,14 +472,18 @@ do
     #
     if $err
     then
-       bad="$bad $seq"
+       bad="$bad $seqnum"
        n_bad=`expr $n_bad + 1`
        quick=false
     fi
-    [ -f $seq.notrun ] || try=`expr $try + 1`
+    if [ ! -f $seq.notrun ]
+    then
+       try="$try $seqnum"
+       n_try=`expr $n_try + 1`
+        _check_test_fs
+    fi
     
-    seq="after_$seq"
-    _check_test_fs
+    seq="after_$seqnum"
 done
 
 interrupt=false